VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsOberflaechenAnalyse"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'Copyright (C) 2003  Jrgen Niesner, Stefan Rhrl
'This program is free software; you can redistribute it and/or modify it under the terms of the
'GNU General Public License as published by the Free Software Foundation; either version 2 of the
'License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
'even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License along with this program; if not,
'write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
'
'Auf Deutsch (ohen Garantie fr die bersetzung)
'Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der GNU General Public License,
'wie von der Free Software Foundation verffentlicht, weitergeben und/oder modifizieren, entweder gem
'Version 2 der Lizenz oder (nach Ihrer Option) jeder spteren Version.

'Die Verffentlichung dieses Programms erfolgt in der Hoffnung, da es Ihnen von Nutzen sein wird, aber
'OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FR
'EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.

'Sie sollten eine Kopie der GNU General Public License zusammen mit diesem Programm erhalten haben. Falls
'nicht, schreiben Sie an die Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.

'=========================


' Diese Klasse kopiert die Oberflchenbeschaffenheiten aus dem Draft-Dokument in eine eigene Zeile und
' gruppiert diese. Falls die Gruppe schon existiert, wird sie vorher gelscht.
' bentigt die Klasse OberflaechenSymbole !!!

Option Explicit

Const constOberflaechenSymboleGruppenName = "OberflaechenSymbole"

Private dXstartPunkt As Double, dYstartPunkt As Double                  ' Start der Symbolreihe
Private dXfreierRaum As Double                                          ' Freiraum zwischen den Symbolen

Private DraftDoc As SolidEdgeDraft.DraftDocument
Private alleSymbole As clsOberflaechenSymbole                           ' Die Sammlung der Oberflaechensymbole

' Konstruktor
Private Sub Class_Initialize()
    dXfreierRaum = 0.005                                                ' sieht gut aus
    
    dYstartPunkt = 0.085                                                ' Normma (Schriftfeldhhe)!
    dXstartPunkt = 0                                                    ' wirt erst spter eingestellt
    
    Set alleSymbole = New clsOberflaechenSymbole                        ' neue Symbol-Sammlung erzeugen
End Sub
' Destruktor
Private Sub Class_Terminate()
    Set DraftDoc = Nothing                                              ' Objekte wieder freigeben
    Set alleSymbole = Nothing
End Sub

' Diese Prozedur entfernt zuerst bei Bedarf die vorherige Gruppe von Symbolen, bergibt alle relevanten
' Daten an die Klasse und startet das Auslesen der freien und gruppierten Oberflchensymbole
Public Sub starten(ByVal DraftDoc_ As SolidEdgeDraft.DraftDocument, ByVal LabelMeldung As Label)
    Dim lGruppenNummer As Long                                          ' Zhlervariablen
    Dim lElement As Long
       
    Set DraftDoc = DraftDoc_                                            ' lokal speichern
  
    DraftDoc.SelectSet.RemoveAll                                        ' falls ein Element selektiert ist, dann Selektion entfernen !!!
    
    lGruppenNummer = erzeugeNeueGruppe(constOberflaechenSymboleGruppenName) ' neue Gruppe anlegen und evtl. alte lschen
                                                                        ' und Position merken !
    LabelMeldung.Caption = "Suche Symbole..."
    alleSymbole.initialisiere DraftDoc, dXfreierRaum, dXstartPunkt, dYstartPunkt ' Variablen an Klasse bergeben
    
    With DraftDoc.ActiveSheet
        leseSymboleAus                                                  ' die freien Symbole
        For lElement = 1 To .Groups.Count - 1                           ' die gruppierten Symbole ohne die neuerstellte Gruppe (-1)
            leseSymboleAus lElement
        Next lElement
    End With
    
    LabelMeldung.Caption = "Sortiere Symbole..."
    
    With alleSymbole
        .sortiereSymbole                                               ' sortieren
        .verschiebeSymbole                                             ' verschieben
        .addToGruppe lGruppenNummer                              ' alle neuen Symbole gruppieren incl. Klammern
    End With
End Sub
' liest die einzelnen Symbole aus (gruppierte und nicht-gruppierte) und trgt sie in die Gruppe ein
' RETURN: nix
Private Sub leseSymboleAus(Optional ByVal lGruppenNummer As Long = 0)
    Dim lElement As Long
    
    If (lGruppenNummer = 0) Then
        With DraftDoc.ActiveSheet.SurfaceFinishSymbols
            For lElement = 1 To .Count                        ' alle Elemente durchgehen
                ersetzePunktDurchKomma .Item(lElement)
                alleSymbole.ergaenzeSymbol .Item(lElement)    ' neues Element hinzufgen
                DoEvents
            Next lElement                                                          '
        End With
    Else
        With DraftDoc.ActiveSheet.Groups.Item(lGruppenNummer).SurfaceFinishSymbols
            For lElement = 1 To .Count                        ' alle Elemente durchgehen
                ersetzePunktDurchKomma .Item(lElement)
                alleSymbole.ergaenzeSymbol .Item(lElement)    ' neues Element hinzufgen
                DoEvents
            Next lElement                                                          '
        End With
    End If
End Sub

' Entfernt die alte Oberflaechensymbol-Gruppe falls sie bereits existieren sollte
' und speichert deren Postition zwischen !
Private Function erzeugeNeueGruppe(ByVal sGruppenName As String) As Long 'As Group
    Dim lElement As Long                                                ' Zhlervariablen
    Dim dXmin As Double, dYmin As Double, dXmax As Double, dYmax As Double
    
    With DraftDoc.ActiveSheet.Groups                                    ' alle Gruppen durchsuchen
        For lElement = 1 To .Count                                      ' falls die Gruppe schon existiert
            If (.Item(lElement).UserDefinedName = sGruppenName) Then
                .Item(lElement).Range dXmin, dYmin, dXmax, dYmax        '    dann Position ermitteln
                dXstartPunkt = dXmin                                    '    und die Koordinaten
                dYstartPunkt = dYmin                                    '    speichern
                .Item(lElement).Delete                                  '    dann Gruppe lschen
                Exit For                                                '    und fertig
            End If
        Next lElement
        
        .Add sGruppenName                                               ' neue Gruppe erzeugen
        erzeugeNeueGruppe = .Count
    End With
End Function

' ersetzt bei einer Zahl, die mit "." geschrieben ist, diesen durch "," => "3.4" => "3,4" BYREF !!!
Private Sub ersetzePunktDurchKomma(ByRef sfsSurfaceFinishSymbol As SolidEdgeFrameworkSupport.SurfaceFinishSymbol)
    With sfsSurfaceFinishSymbol
        .ProductionMethod = ersetzePunktDurchKommaString(.ProductionMethod)
        .SamplingLength = ersetzePunktDurchKommaString(.SamplingLength)
        .RoughnessWidthCutOff = ersetzePunktDurchKommaString(.RoughnessWidthCutOff)
        .SurfaceLaySymbol = ersetzePunktDurchKommaString(.SurfaceLaySymbol)
        .SurfaceFinishSymbol = ersetzePunktDurchKommaString(.SurfaceFinishSymbol)
        .MaximumRoughnessValue = ersetzePunktDurchKommaString(.MaximumRoughnessValue)
        .MinimumRoughnessValue = ersetzePunktDurchKommaString(.MinimumRoughnessValue)
        .MachiningAllowance = ersetzePunktDurchKommaString(.MachiningAllowance)
    End With
End Sub
Private Function ersetzePunktDurchKommaString(ByVal sWert As String) As String
    If (IsNumeric(sWert)) Then                              ' wenns eine Zahl ist
        sWert = Replace(sWert, ".", ",", , , vbTextCompare)
    End If
    
    ersetzePunktDurchKommaString = sWert
End Function
