VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsOberflaechenSymbole"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "Die Collection der Oberflaechensymbole"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"OberflaechenSymbol"
Attribute VB_Ext_KEY = "Member0" ,"OberflaechenSymbol"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'Copyright (C) 2003  Jrgen Niesner, Stefan Rhrl
'This program is free software; you can redistribute it and/or modify it under the terms of the
'GNU General Public License as published by the Free Software Foundation; either version 2 of the
'License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
'even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License along with this program; if not,
'write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
'
'Auf Deutsch (ohen Garantie fr die bersetzung)
'Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der GNU General Public License,
'wie von der Free Software Foundation verffentlicht, weitergeben und/oder modifizieren, entweder gem
'Version 2 der Lizenz oder (nach Ihrer Option) jeder spteren Version.

'Die Verffentlichung dieses Programms erfolgt in der Hoffnung, da es Ihnen von Nutzen sein wird, aber
'OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FR
'EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.

'Sie sollten eine Kopie der GNU General Public License zusammen mit diesem Programm erhalten haben. Falls
'nicht, schreiben Sie an die Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.

'=========================


' Diese Klasse verwaltet die neu hinzugefgten OberflchenSymbole. Zuerst muss die Klasse mit
' init initialisiert werden, danach werden die Objekte mit add hinzugefgt.
Option Explicit

Private dXfreierRaum As Double                                          ' Freier Raum zwischen den Symbolen
Private dXstartPunkt As Double                                          ' Startpunkt x-Koordinate
Private dYstartPunkt As Double                                          ' Startpunkt y-Koordinate
Private dKlammerHoehe As Double                                         ' die Hhe der rechten und linken Klammer 0.01
Private dXneu As Double
Private dYneu As Double

Private alleSymbole As Collection                                       ' Die eigentliche Auflistung
Private DraftDoc As SolidEdgeDraft.DraftDocument                        '

' Konstruktor
Private Sub Class_Initialize()
    Set alleSymbole = New Collection                                    ' neue Auflistung erstellen
    dKlammerHoehe = 0.015
End Sub

' Daten an die Klasse bergeben
Public Sub initialisiere(ByVal DraftDoc_ As SolidEdgeDraft.DraftDocument, _
                ByVal dXfreierRaum_ As Double, ByVal dXstartPunkt_ As Double, ByVal dYstartPunkt_ As Double)
    Set DraftDoc = DraftDoc_
    dXfreierRaum = dXfreierRaum_
    dXstartPunkt = dXstartPunkt_
    dYstartPunkt = dYstartPunkt_
  
    dXneu = dXstartPunkt
    dYneu = dYstartPunkt
End Sub

' Destruktor
Private Sub Class_Terminate()
    Set DraftDoc = Nothing                                              ' Objekte wieder
    Set alleSymbole = Nothing                                           ' freigeben
End Sub

' neue Elemente hinzufgen und gleich berprfen, ob schon vorhanden ist (und richtig sortieren)
Public Sub ergaenzeSymbol(ByVal zuKopierendesSymbol As SurfaceFinishSymbol)
    Dim lAktuellesElement As Long
    Dim bElementSchonVorhanden As Boolean
    Dim neuesSymbol As SurfaceFinishSymbol                              ' das neu erstellte Symbol
          
    If (istVorGruppe(zuKopierendesSymbol) = 0) Then                     ' das StandardSymbol nicht mit
        Exit Sub                                                        ' in die Gruppe aufnehmen !
    End If

    bElementSchonVorhanden = False                                      ' hier werden doppelte Symbole mitgezhlt
    
    For lAktuellesElement = 1 To alleSymbole.Count                      ' ist das Symbol schon vorhanden ?
        If (istIdentisch(alleSymbole.Item(lAktuellesElement), zuKopierendesSymbol) = 0) Then
            bElementSchonVorhanden = True                               ' schon vorhanden !
            Exit For
        End If
    Next lAktuellesElement
    
    If (bElementSchonVorhanden = False) Then                            ' falls noch nicht da
        'Set neuesSymbol = zuKopierendesSymbol.Duplicate(0.1, 0.1)      ' funktioniert nicht mit SE V9, V12
        
        zuKopierendesSymbol.Copy                                        ' deshalb Element kopieren und
        DraftDoc.Windows.Item(1).Paste                                  ' ins 1. Fenster wieder einfgen
        
        Set neuesSymbol = DraftDoc.ActiveSheet.SurfaceFinishSymbols.Item(DraftDoc.ActiveSheet.SurfaceFinishSymbols.Count)
        
        alleSymbole.Add neuesSymbol                                     ' und einfach hinten anfgen
        Set neuesSymbol = Nothing
    End If
End Sub

' Sortiert die neuen Oberflaechensymbole
Public Sub sortiereSymbole()
    Dim lSortiert As Long, lAktuellePosition As Long
    Dim lLetztesElement As Long
    Dim lPosition As Long                                               ' Die Position beim Durchsuchen der Elemente
    Dim bElementEinsortiert As Boolean
    
    Dim sfsElement As SurfaceFinishSymbol                               ' das gerade verwendete Symbol
   
    With alleSymbole
    If (.Count > 1) Then                                                ' nicht ausfhren, wenn nur ein einziges Symbol da ist
        lSortiert = 0
        For lAktuellePosition = 1 To .Count                             ' unbearbeitet
            If (.Item(lAktuellePosition).SurfaceFinishSymbol = igDimSurfaceFinishNoMaterialRemoval) Then
                Set sfsElement = .Item(lAktuellePosition)               ' kopieren
                .Remove lAktuellePosition                               ' entfernen
                .Add sfsElement, , 1                                    ' ganz am Anfang positionieren
                lSortiert = lSortiert + 1
            End If                                                      ' bis hier ist schon sortiert !
        Next lAktuellePosition
        
        lSortiert = lSortiert + 1                                       ' ab dem nchsten Element starten
        lLetztesElement = 1                                             ' so viele bearbeitete bis jetzt
        
        For lAktuellePosition = lSortiert + 1 To .Count                 ' bearbeitet => absteigend sortieren
            If (.Item(lAktuellePosition).SurfaceFinishSymbol = igDimSurfaceFinishMachined) Then
                bElementEinsortiert = False                             ' noch nicht einsortiert !
                                   
                For lPosition = 0 To lLetztesElement - 1                ' bis hierher reichen die bearbeiteten Elemente
                     If (dNachDouble(.Item(lAktuellePosition).MinimumRoughnessValue) <= _
                         dNachDouble(.Item(lPosition + lSortiert).MinimumRoughnessValue)) Then
                        Set sfsElement = .Item(lAktuellePosition)       ' das aktuelle Element
                        .Remove lAktuellePosition                       ' ausschneiden und
                        .Add sfsElement, , lPosition + lSortiert        ' vor dem Kleineren einfgen
                        bElementEinsortiert = True                      '
                        Exit For                                        ' fertig !
                     End If
                Next lPosition
               
                If (bElementEinsortiert = False) Then                   ' falls Element noch nicht einsortiert ist
                    Set sfsElement = .Item(lAktuellePosition)           '           => ist das momentan grte !
                    .Remove lAktuellePosition                           ' ausschneiden und
                    .Add sfsElement, , , lLetztesElement + lSortiert - 1   ' am Ende einfgen (aber davor !)
                End If
                lLetztesElement = lLetztesElement + 1                   ' jetzt ist ein Element mehr einsortiert
            End If
        Next lAktuellePosition
    End If
    End With
End Sub

' Verschiebt die neuen Symbole an die entsprechenden Stellen dxneu = 0, dYneu = 0.085, dXfreierRaum = 0.005
Public Sub verschiebeSymbole()
    Dim dXmin As Double, dYmin As Double, dXmax As Double, dYmax As Double
    Dim lAktuellesElement As Long

    For lAktuellesElement = 1 To Me.Count                               ' alle neuen Elemente durchgehen
        With Me.Item(lAktuellesElement)
            .Leader = False                                             ' Pfeil entfernen !!
            .Range dXmin, dYmin, dXmax, dYmax                           ' Position ermitteln
            'dXmin = 0
            ' Hier werden Symbole, bei denen dYmin negativ ist, nicht verschoben

            .Move dXmin, dYmin, dXneu, dYneu                            ' und verschieben
        End With
        dXneu = dXneu + (dXmax - dXmin) + dXfreierRaum                  ' Position fr das nchste Element
    Next lAktuellesElement
End Sub

' fgt alle Elemente der Gruppe hinzu
' ACHTUNG: seit V12 muss nach jedem .AddToGroup ein SelectSet.RemoveAll folgen, da das Programm ansonsten abbricht.
'          Keine Ahnung, warum !
Public Sub addToGruppe(ByVal lGruppenNummer As Long)
    Dim dXmin As Double, dYmin As Double, dXmax As Double, dYmax As Double
    Dim i As Long
    Dim lAnzahlTextBoxen As Long
    
    With DraftDoc.ActiveSheet                                           ' "(" und ")" erzeugen und zu der Gruppe hinzufgen
        
        lAnzahlTextBoxen = .TextBoxes.Count                             ' die bisher verwendeten TextBoxen
        
        .TextBoxes.AddByTwoPoints dXstartPunkt - dXfreierRaum, dYstartPunkt, 0, dXstartPunkt, dYstartPunkt + dKlammerHoehe, 0
        With .TextBoxes.Item(lAnzahlTextBoxen + 1)                      ' linke Klammer
            .Text = "("                                                 ' "("
            .Edit.SetSelect 1, 1, seTextSelectAll
            .Edit.TextSize = dKlammerHoehe
            .Select
        End With
        .Groups.Item(lGruppenNummer).AddToGroup                         ' gruppieren => Anzahl--
        DraftDoc.SelectSet.RemoveAll
        
        .TextBoxes.AddByTwoPoints dXneu, dYstartPunkt, 0, dXneu, dYstartPunkt + dKlammerHoehe, 0
        With .TextBoxes.Item(lAnzahlTextBoxen + 1)                      ' rechte Klammer
            .Text = ")"                                                 ' und ")"
            .Edit.SetSelect 1, 1, seTextSelectAll
            .Edit.TextSize = dKlammerHoehe
            .Select
        End With
        .Groups.Item(lGruppenNummer).AddToGroup
        DraftDoc.SelectSet.RemoveAll
        
        With .Groups.Item(lGruppenNummer)
            For i = 1 To Me.Count                                       ' alle Elemente durchgehen
                Me.Item(i).Select
                .AddToGroup                                             ' und in die Gruppe eintragen
                DraftDoc.SelectSet.RemoveAll
            Next i
            
            .Range dXmin, dYmin, dXmax, dYmax                           ' Position ermitteln (nachjustieren !)
            
            If (dXstartPunkt = 0) Then                                      ' falls noch vorher keine Gruppe da war
                .Move dXmax, dYmin, _
                        DraftDoc.ActiveSheet.SheetSetup.SheetWidth - 3 * dXfreierRaum, dYmin ' dann ganz nach rechts verschieben
            Else
                .Move dXmin, dYmin, dXmin + dXfreierRaum, dYmin + dKlammerHoehe * 0.65
            End If
        End With
    End With
End Sub
' Vergleicht 2 Oberflchensymbole anhand der 8 (!) Eigenschaften. Achtung, falls bei einem Wert ein LEERZEICHEN eingetragen wurde, sind das zwei unterschiedliche Werte !
'RETURN: 0 bei Erfolg, -1 bei Fehler
Private Function istIdentisch(ByVal Symbol1 As SurfaceFinishSymbol, ByVal Symbol2 As SurfaceFinishSymbol) As Long
    Dim lAnzahlOK As Long
    
    lAnzahlOK = 0
    
    With Symbol1
        If (.ProductionMethod = Symbol2.ProductionMethod) Then lAnzahlOK = lAnzahlOK + 1
        If (.SamplingLength = Symbol2.SamplingLength) Then lAnzahlOK = lAnzahlOK + 1
        If (.RoughnessWidthCutOff = Symbol2.RoughnessWidthCutOff) Then lAnzahlOK = lAnzahlOK + 1
        If (.SurfaceLaySymbol = Symbol2.SurfaceLaySymbol) Then lAnzahlOK = lAnzahlOK + 1
        If (.SurfaceFinishSymbol = Symbol2.SurfaceFinishSymbol) Then lAnzahlOK = lAnzahlOK + 1
        If (.MaximumRoughnessValue = Symbol2.MaximumRoughnessValue) Then lAnzahlOK = lAnzahlOK + 1
        If (.MinimumRoughnessValue = Symbol2.MinimumRoughnessValue) Then lAnzahlOK = lAnzahlOK + 1
        If (.MachiningAllowance = Symbol2.MachiningAllowance) Then lAnzahlOK = lAnzahlOK + 1
    End With
    
    If (lAnzahlOK = 8) Then
        istIdentisch = 0
    Else
        istIdentisch = -1
    End If
End Function

' gibt an, ob das Symbol direkt vor der Gruppe steht (=> wird nicht mitgezhlt !)
' RETURN 0 bei ja, -1 bei nein
Private Function istVorGruppe(ByVal Symbol1 As SurfaceFinishSymbol) As Long
    Dim dXmin As Double, dYmin As Double, dXmax As Double, dYmax As Double
    
    istVorGruppe = -1                                                   ' Standardwert = nicht vor der Gruppe
    
    If (dXstartPunkt <> 0) Then                                         ' falls vorher schon eine Gruppe da war
        Symbol1.Range dXmin, dYmin, dXmax, dYmax                        ' Position ermitteln
                                                                        ' 0.01 als Abweichung
        If (Abs(dXstartPunkt - dXmax - 2 * dXfreierRaum) < 0.01 And Abs(dYstartPunkt - dYmin) < 0.01) Then  ' gilt noch !
            istVorGruppe = 0
        End If
    End If
End Function

' Zugriff auf ein objekt entweder per Name oder Nummer
Public Property Get Item(ByVal vntIndexKey As Variant) As SurfaceFinishSymbol
Attribute Item.VB_UserMemId = 0
    Set Item = alleSymbole(vntIndexKey)
End Property

' Liefert die Anzahl der Elemente zurck
Public Property Get Count() As Long
    Count = alleSymbole.Count
End Property

' Entfernt ein Element entweder per Name oder Nummer
Public Sub Remove(ByVal vntIndexKey As Variant)
    alleSymbole.Remove vntIndexKey
End Sub

' diese Funktion Konvertiert einen beliebigen Wert nach Double
Private Function dNachDouble(ByVal varWert As Variant) As Double
    On Error Resume Next
    If (varWert = "" Or varWert = " ") Then
        dNachDouble = 0
    Else
        dNachDouble = CDbl(varWert)
        If (Err <> 0) Then                      ' Fehler beim konvertieren !
            Err.Clear
            dNachDouble = 0
        End If
    End If
    
End Function
